/* 
  Magnum 
  Copyright (C) 2002-2005 Kaya Memisoglu. All Rights Reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, under the terms in LICENSE.TXT.

  Kaya Memisoglu  (k.memisoglu@dimajix.de)
*/

#include "graphics.h"
#include "gui.h"


namespace magnum { namespace sample {
using magnum::graphics3d::Context;
using magnum::graphics::Colour;

/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
GraphicsView::GraphicsView(const Rectangle<float>& rect) : OpenGL(rect) {
	setColourBits(24);
	setAlphaBits(8);
	setDepthBits(24);
	setStencilBits(8);
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool GraphicsView::onAttachWindow() {
	OpenGL::onAttachWindow();

	m_Context = Context::getCurrent();
	m_Context->setCulling(Context::CullBack);

	m_MatrixStack = m_Context->getMatrixStack();

	m_Context->setClearColour(Colour<float>(0,0,0));
	m_Context->setViewport(getBounds());
	
	m_Gui = new Gui(m_Context);
	m_Gui->attachDirectInput();
	
	m_Timer.init(0);
	
	return onInit();
}


/*----------------------------------------------------------------------------
----------------------------------------------------------------------------*/
bool GraphicsView::onDetachWindow() {
	onExit();
	m_Gui->release();
	return OpenGL::onDetachWindow();
}

}; };
